import MarkdownIt from 'markdown-it';
import type MdAnchor from 'markdown-it-anchor';
import { Options } from 'linkify-it';
import type { PluginWithOptions } from 'markdown-it';
import { RuleBlock } from 'markdown-it/lib/parser_block';

export declare const anchorOption: MdAnchor.AnchorOptions;

export declare const defaultLinkifyOptions: LinkifyOption;

export declare const defaultMarkdownItOption: MarkdownItPresetOption;

export declare const defaultTaskListsOption: TaskListsOption;

export declare interface HighlightCodeLinesOptions {
    enable?: (md: MarkdownIt) => boolean;
}

export declare const HighlightCodeLinesPlugin: PluginWithOptions<HighlightCodeLinesOptions>;

declare type LinkifyOption = Options & {
    fuzzyLinkUseHttps?: boolean;
};

export { MarkdownIt }

export declare const markdownItFactory: ({ html, codeHighlight, taskListsOption, math, disableRules, linkify: linkifyOption, preserveLineBreaks, enableMarkdownAttrs, showFrontMatter, }?: MarkdownItPresetOption) => MarkdownIt;

export declare interface MarkdownItPresetOption {
    codeHighlight: boolean;
    math: boolean;
    html: boolean;
    disableRules: string[];
    taskListsOption?: TaskListsOption;
    linkify?: LinkifyOption;
    preserveLineBreaks?: boolean;
    enableMarkdownAttrs?: boolean;
    showFrontMatter?: boolean;
}

export declare interface MultilineBlockquoteOptions {
    enable?: (md: MarkdownIt) => boolean;
}

export declare const MultilineBlockquotePlugin: PluginWithOptions<MultilineBlockquoteOptions>;

export declare const MultilineBlockquoteRule: RuleBlock;

export declare interface TaskListsOption {
    enable: boolean;
    label: boolean;
    labelAfter: boolean;
}

export { }
